import { CodeLens, CompletionItem, Position, Range } from "vscode-languageserver-types";
import * as jsonc from "jsonc-parser";
import { JSONPath } from "jsonc-parser";
import { SwfServiceCatalogService } from "@kie-tools/serverless-workflow-service-catalog/dist/api";
import { TextDocument } from "vscode-json-languageservice";
import * as ls from "vscode-languageserver-types";
export declare type SwfJsonLanguageServiceConfig = {
    shouldConfigureServiceRegistries: () => boolean;
    shouldServiceRegistriesLogIn: () => boolean;
    canRefreshServices: () => boolean;
    getSpecsDirPosixPaths: (textDocument: TextDocument) => Promise<{
        specsDirRelativePosixPath: string;
        specsDirAbsolutePosixPath: string;
    }>;
    shouldDisplayServiceRegistriesIntegration: () => Promise<boolean>;
    shouldReferenceServiceRegistryFunctionsWithUrls: () => Promise<boolean>;
};
export declare class SwfJsonLanguageService {
    private readonly args;
    constructor(args: {
        fs: {};
        serviceCatalog: {
            global: {
                getServices: () => Promise<SwfServiceCatalogService[]>;
            };
            relative: {
                getServices: (textDocument: TextDocument) => Promise<SwfServiceCatalogService[]>;
            };
            getServiceFileNameFromSwfServiceCatalogServiceId: (registryName: string, swfServiceCatalogServiceId: string) => Promise<string>;
        };
        config: SwfJsonLanguageServiceConfig;
    });
    getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    getDiagnostics(args: {
        content: string;
        uriPath: string;
    }): Promise<ls.Diagnostic[]>;
    getCodeLenses(args: {
        content: string;
        uri: string;
    }): Promise<CodeLens[]>;
    dispose(): void;
    private getSwfCompletionItemServiceCatalogFunctionOperation;
}
export declare function findNodesAtLocation(root: jsonc.Node | undefined, path: JSONPath): jsonc.Node[];
//# sourceMappingURL=SwfJsonLanguageService.d.ts.map