"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findNodesAtLocation = exports.SwfJsonLanguageService = void 0;
var vscode_languageserver_types_1 = require("vscode-languageserver-types");
var jsonc = require("jsonc-parser");
var path_1 = require("path");
var api_1 = require("@kie-tools/serverless-workflow-service-catalog/dist/api");
var swfModelQueries = require("./modelQueries");
var schemas_1 = require("../schemas");
var vscode_json_languageservice_1 = require("vscode-json-languageservice");
var SwfJsonLanguageService = (function () {
    function SwfJsonLanguageService(args) {
        this.args = args;
    }
    SwfJsonLanguageService.prototype.getCompletionItems = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var doc, rootNode, cursorOffset, currentNode, currentNodePosition, overwriteRange, cursorJsonLocation, swfCompletionItemServiceCatalogServices, _a, _b, _c, _d, result;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        doc = vscode_json_languageservice_1.TextDocument.create(args.uri, "json", 0, args.content);
                        rootNode = jsonc.parseTree(args.content);
                        if (!rootNode) {
                            return [2, []];
                        }
                        cursorOffset = doc.offsetAt(args.cursorPosition);
                        currentNode = jsonc.findNodeAtOffset(rootNode, cursorOffset);
                        if (!currentNode) {
                            return [2, []];
                        }
                        currentNodePosition = {
                            start: doc.positionAt(currentNode.offset),
                            end: doc.positionAt(currentNode.offset + currentNode.length),
                        };
                        overwriteRange = ["string", "number", "boolean", "null"].includes(currentNode === null || currentNode === void 0 ? void 0 : currentNode.type)
                            ? vscode_languageserver_types_1.Range.create(currentNodePosition.start, currentNodePosition.end)
                            : args.cursorWordRange;
                        cursorJsonLocation = jsonc.getLocation(args.content, cursorOffset);
                        _b = (_a = Promise).all;
                        _c = [[]];
                        return [4, this.args.serviceCatalog.global.getServices()];
                    case 1:
                        _d = [__spreadArray.apply(void 0, _c.concat([__read.apply(void 0, [(_e.sent())]), false]))];
                        return [4, this.args.serviceCatalog.relative.getServices(doc)];
                    case 2: return [4, _b.apply(_a, [__spreadArray.apply(void 0, _d.concat([__read.apply(void 0, [(_e.sent())]), false])).map(function (service) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                var _b;
                                var _this = this;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _a = [__assign({}, service)];
                                            _b = {};
                                            return [4, Promise.all(service.functions.map(function (func) { return __awaiter(_this, void 0, void 0, function () {
                                                    var _a;
                                                    var _b;
                                                    return __generator(this, function (_c) {
                                                        switch (_c.label) {
                                                            case 0:
                                                                _a = [__assign({}, func)];
                                                                _b = {};
                                                                return [4, this.getSwfCompletionItemServiceCatalogFunctionOperation(service, func, doc)];
                                                            case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.operation = _c.sent(), _b)])))];
                                                        }
                                                    });
                                                }); }))];
                                        case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.functions = _c.sent(), _b)])))];
                                    }
                                });
                            }); })])];
                    case 3:
                        swfCompletionItemServiceCatalogServices = _e.sent();
                        return [4, Promise.all(Array.from(completions.entries())
                                .filter(function (_a) {
                                var _b = __read(_a, 2), path = _b[0], _ = _b[1];
                                return cursorJsonLocation.matches(path) && cursorJsonLocation.path.length === path.length;
                            })
                                .map(function (_a) {
                                var _b = __read(_a, 2), _ = _b[0], completionItemsDelegate = _b[1];
                                return completionItemsDelegate({
                                    document: doc,
                                    cursorPosition: args.cursorPosition,
                                    currentNode: currentNode,
                                    currentNodePosition: currentNodePosition,
                                    rootNode: rootNode,
                                    overwriteRange: overwriteRange,
                                    swfCompletionItemServiceCatalogServices: swfCompletionItemServiceCatalogServices,
                                    langServiceConfig: _this.args.config,
                                });
                            }))];
                    case 4:
                        result = _e.sent();
                        return [2, Promise.resolve(result.flat())];
                }
            });
        });
    };
    SwfJsonLanguageService.prototype.getDiagnostics = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var textDocument, schemaUri, jsonLanguageService, jsonDocument;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        textDocument = vscode_json_languageservice_1.TextDocument.create(args.uriPath, "serverless-workflow-json", 1, args.content);
                        schemaUri = "https://serverlessworkflow.io/schemas/0.8/workflow.json";
                        jsonLanguageService = (0, vscode_json_languageservice_1.getLanguageService)({
                            schemaRequestService: function (uri) {
                                if (uri === schemaUri) {
                                    return Promise.resolve(JSON.stringify(schemas_1.SW_SPEC_WORKFLOW_SCHEMA));
                                }
                                return Promise.reject("Unabled to load schema at ".concat(uri));
                            },
                        });
                        jsonLanguageService.configure({
                            allowComments: false,
                            schemas: [{ fileMatch: ["*.sw.json"], uri: schemaUri }],
                        });
                        jsonDocument = jsonLanguageService.parseJSONDocument(textDocument);
                        return [4, jsonLanguageService.doValidation(textDocument, jsonDocument)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    SwfJsonLanguageService.prototype.getCodeLenses = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var document, rootNode, addFunction, setupServiceRegistries, logInServiceRegistries, refreshServiceRegistries, displayRhhccIntegration;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        document = vscode_json_languageservice_1.TextDocument.create(args.uri, "json", 0, args.content);
                        rootNode = jsonc.parseTree(document.getText());
                        if (!rootNode) {
                            return [2, []];
                        }
                        addFunction = createCodeLenses({
                            document: document,
                            rootNode: rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                var newCursorPosition = document.positionAt(node.offset + 1);
                                return [
                                    {
                                        name: "swf.ls.commands.OpenFunctionsCompletionItems",
                                        title: "+ Add function...",
                                        args: [
                                            { newCursorPosition: newCursorPosition },
                                        ],
                                    },
                                ];
                            },
                        });
                        setupServiceRegistries = createCodeLenses({
                            document: document,
                            rootNode: rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (!_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.OpenServiceRegistriesConfig",
                                        title: "↪ Setup Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        logInServiceRegistries = createCodeLenses({
                            document: document,
                            rootNode: rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                if (!_this.args.config.shouldServiceRegistriesLogIn()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.LogInServiceRegistries",
                                        title: "↪ Log in Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        refreshServiceRegistries = createCodeLenses({
                            document: document,
                            rootNode: rootNode,
                            jsonPath: ["functions"],
                            positionLensAt: "begin",
                            commandDelegates: function (_a) {
                                var position = _a.position, node = _a.node;
                                if (node.type !== "array") {
                                    return [];
                                }
                                if (_this.args.config.shouldConfigureServiceRegistries()) {
                                    return [];
                                }
                                if (!_this.args.config.canRefreshServices()) {
                                    return [];
                                }
                                return [
                                    {
                                        name: "swf.ls.commands.RefreshServiceRegistries",
                                        title: "↺ Refresh Service Registries...",
                                        args: [{ position: position }],
                                    },
                                ];
                            },
                        });
                        return [4, this.args.config.shouldDisplayServiceRegistriesIntegration()];
                    case 1:
                        displayRhhccIntegration = _a.sent();
                        return [2, __spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read((displayRhhccIntegration ? setupServiceRegistries : [])), false), __read((displayRhhccIntegration ? logInServiceRegistries : [])), false), __read((displayRhhccIntegration ? refreshServiceRegistries : [])), false), __read(addFunction), false)];
                }
            });
        });
    };
    SwfJsonLanguageService.prototype.dispose = function () {
    };
    SwfJsonLanguageService.prototype.getSwfCompletionItemServiceCatalogFunctionOperation = function (containingService, func, document) {
        return __awaiter(this, void 0, void 0, function () {
            var specsDirRelativePosixPath, serviceFileName, serviceFileRelativePosixPath, serviceFileName, serviceFileRelativePosixPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.args.config.getSpecsDirPosixPaths(document)];
                    case 1:
                        specsDirRelativePosixPath = (_a.sent()).specsDirRelativePosixPath;
                        if (!(func.source.type === api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS)) return [3, 2];
                        serviceFileName = path_1.posix.basename(func.source.serviceFileAbsolutePath);
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 2: return [4, this.args.config.shouldReferenceServiceRegistryFunctionsWithUrls()];
                    case 3:
                        if (!((_a.sent()) &&
                            containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 4];
                        return [2, "".concat(containingService.source.url, "#").concat(func.name)];
                    case 4:
                        if (!(containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 6];
                        return [4, this.args.serviceCatalog.getServiceFileNameFromSwfServiceCatalogServiceId(containingService.source.registry, containingService.source.id)];
                    case 5:
                        serviceFileName = _a.sent();
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 6: throw new Error("Unknown Service Catalog function source type");
                }
            });
        });
    };
    return SwfJsonLanguageService;
}());
exports.SwfJsonLanguageService = SwfJsonLanguageService;
var completions = new Map([
    [
        ["functions", "*"],
        function (_a) {
            var currentNode = _a.currentNode, rootNode = _a.rootNode, overwriteRange = _a.overwriteRange, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices, document = _a.document, langServiceConfig = _a.langServiceConfig;
            return __awaiter(void 0, void 0, void 0, function () {
                var separator, existingFunctionOperations, specsDir, result;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            separator = currentNode.type === "object" ? "," : "";
                            existingFunctionOperations = swfModelQueries.getFunctions(rootNode).map(function (f) { return f.operation; });
                            return [4, langServiceConfig.getSpecsDirPosixPaths(document)];
                        case 1:
                            specsDir = _b.sent();
                            result = swfCompletionItemServiceCatalogServices.flatMap(function (swfServiceCatalogService) {
                                return swfServiceCatalogService.functions
                                    .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
                                    .map(function (swfServiceCatalogFunc) {
                                    var swfFunction = {
                                        name: "${1:".concat(swfServiceCatalogFunc.name, "}"),
                                        operation: swfServiceCatalogFunc.operation,
                                        type: swfServiceCatalogFunc.type,
                                    };
                                    var command = {
                                        name: "swf.ls.commands.ImportFunctionFromCompletionItem",
                                        args: {
                                            containingService: swfServiceCatalogService,
                                            documentUri: document.uri,
                                        },
                                    };
                                    return {
                                        kind: swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                                            ? vscode_languageserver_types_1.CompletionItemKind.Interface
                                            : vscode_languageserver_types_1.CompletionItemKind.Reference,
                                        label: toCompletionItemLabelPrefix(swfServiceCatalogFunc, specsDir.specsDirRelativePosixPath),
                                        detail: swfServiceCatalogService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY
                                            ? swfServiceCatalogService.source.url
                                            : swfServiceCatalogFunc.operation,
                                        textEdit: {
                                            newText: JSON.stringify(swfFunction, null, 2) + separator,
                                            range: overwriteRange,
                                        },
                                        snippet: true,
                                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                                        command: {
                                            command: command.name,
                                            title: "Import function from completion item",
                                            arguments: [command.args],
                                        },
                                    };
                                });
                            });
                            return [2, Promise.resolve(result)];
                    }
                });
            });
        },
    ],
    [
        ["functions", "*", "operation"],
        function (_a) {
            var _b, _c, _d;
            var currentNode = _a.currentNode, rootNode = _a.rootNode, overwriteRange = _a.overwriteRange, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices;
            if (!((_b = currentNode.parent) === null || _b === void 0 ? void 0 : _b.parent)) {
                return Promise.resolve([]);
            }
            var isRestFunction = ((_d = (_c = jsonc.findNodeAtLocation(currentNode.parent.parent, ["type"])) === null || _c === void 0 ? void 0 : _c.value) !== null && _d !== void 0 ? _d : "rest") === "rest";
            if (!isRestFunction) {
                return Promise.resolve([]);
            }
            var existingFunctionOperations = swfModelQueries.getFunctions(rootNode).map(function (f) { return f.operation; });
            var result = swfCompletionItemServiceCatalogServices
                .flatMap(function (s) { return s.functions; })
                .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
                .map(function (swfServiceCatalogFunc) {
                return {
                    kind: swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                        ? vscode_languageserver_types_1.CompletionItemKind.Function
                        : vscode_languageserver_types_1.CompletionItemKind.Folder,
                    label: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    detail: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    filterText: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                    textEdit: {
                        newText: "\"".concat(swfServiceCatalogFunc.operation, "\""),
                        range: overwriteRange,
                    },
                    insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                };
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef"],
        function (_a) {
            var overwriteRange = _a.overwriteRange, currentNode = _a.currentNode, rootNode = _a.rootNode, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices;
            if (currentNode.type !== "property") {
                console.debug("Cannot autocomplete: functionRef should be a property.");
                return Promise.resolve([]);
            }
            var result = swfModelQueries.getFunctions(rootNode).flatMap(function (swfFunction) {
                var swfServiceCatalogFunc = swfCompletionItemServiceCatalogServices
                    .flatMap(function (f) { return f.functions; })
                    .filter(function (f) { return f.operation === swfFunction.operation; })
                    .pop();
                if (!swfServiceCatalogFunc) {
                    return [];
                }
                var argIndex = 1;
                var swfFunctionRefArgs = {};
                Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
                    swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
                });
                var swfFunctionRef = {
                    refName: swfFunction.name,
                    arguments: swfFunctionRefArgs,
                };
                return [
                    {
                        kind: vscode_languageserver_types_1.CompletionItemKind.Module,
                        label: "".concat(swfFunctionRef.refName),
                        sortText: "".concat(swfFunctionRef.refName),
                        detail: "".concat(swfServiceCatalogFunc.operation),
                        textEdit: {
                            newText: JSON.stringify(swfFunctionRef, null, 2),
                            range: overwriteRange,
                        },
                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                    },
                ];
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef", "refName"],
        function (_a) {
            var overwriteRange = _a.overwriteRange, rootNode = _a.rootNode;
            var result = swfModelQueries.getFunctions(rootNode).flatMap(function (swfFunction) {
                return [
                    {
                        kind: vscode_languageserver_types_1.CompletionItemKind.Value,
                        label: "\"".concat(swfFunction.name, "\""),
                        sortText: "\"".concat(swfFunction.name, "\""),
                        detail: "\"".concat(swfFunction.name, "\""),
                        filterText: "\"".concat(swfFunction.name, "\""),
                        textEdit: {
                            newText: "\"".concat(swfFunction.name, "\""),
                            range: overwriteRange,
                        },
                        insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                    },
                ];
            });
            return Promise.resolve(result);
        },
    ],
    [
        ["states", "*", "actions", "*", "functionRef", "arguments"],
        function (_a) {
            var _b, _c;
            var overwriteRange = _a.overwriteRange, currentNode = _a.currentNode, rootNode = _a.rootNode, swfCompletionItemServiceCatalogServices = _a.swfCompletionItemServiceCatalogServices;
            if (currentNode.type !== "property") {
                console.debug("Cannot autocomplete: functionRef should be a property.");
                return Promise.resolve([]);
            }
            if (!currentNode.parent) {
                return Promise.resolve([]);
            }
            var swfFunctionRefName = (_b = jsonc.findNodeAtLocation(currentNode.parent, ["refName"])) === null || _b === void 0 ? void 0 : _b.value;
            if (!swfFunctionRefName) {
                return Promise.resolve([]);
            }
            var swfFunction = (_c = swfModelQueries
                .getFunctions(rootNode)) === null || _c === void 0 ? void 0 : _c.filter(function (f) { return f.name === swfFunctionRefName; }).pop();
            if (!swfFunction) {
                return Promise.resolve([]);
            }
            var swfServiceCatalogFunc = swfCompletionItemServiceCatalogServices
                .flatMap(function (f) { return f.functions; })
                .filter(function (f) { return f.operation === swfFunction.operation; })
                .pop();
            if (!swfServiceCatalogFunc) {
                return Promise.resolve([]);
            }
            var argIndex = 1;
            var swfFunctionRefArgs = {};
            Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
                swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
            });
            return Promise.resolve([
                {
                    kind: vscode_languageserver_types_1.CompletionItemKind.Module,
                    label: "'".concat(swfFunctionRefName, "' arguments"),
                    sortText: "".concat(swfFunctionRefName, " arguments"),
                    detail: swfFunction.operation,
                    textEdit: {
                        newText: JSON.stringify(swfFunctionRefArgs, null, 2),
                        range: overwriteRange,
                    },
                    insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
                },
            ]);
        },
    ],
]);
function toCompletionItemLabelPrefix(swfServiceCatalogFunction, specsDirRelativePosixPath) {
    var _a;
    switch (swfServiceCatalogFunction.source.type) {
        case api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS:
            var fileName = (_a = swfServiceCatalogFunction.source.serviceFileAbsolutePath.split("/").pop()) !== null && _a !== void 0 ? _a : swfServiceCatalogFunction.source.serviceFileAbsolutePath;
            return toCompletionItemLabel(specsDirRelativePosixPath, fileName, swfServiceCatalogFunction.name);
        case api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY:
            return toCompletionItemLabel(swfServiceCatalogFunction.source.registry, swfServiceCatalogFunction.source.serviceId, swfServiceCatalogFunction.name);
        default:
            return "";
    }
}
function toCompletionItemLabel(namespace, resource, operation) {
    return "".concat(namespace, "\u00BB").concat(resource, "#").concat(operation);
}
function createCodeLenses(args) {
    var nodes = findNodesAtLocation(args.rootNode, args.jsonPath);
    return nodes.flatMap(function (node) {
        var _a, _b;
        var position = args.positionLensAt === "end" &&
            (node.type === "object" || node.type === "array") &&
            ((_b = (_a = node.children) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0
            ? args.document.positionAt(node.offset + node.length)
            : args.document.positionAt(node.offset);
        return args.commandDelegates({ position: position, node: node }).map(function (command) { return ({
            command: {
                command: command.name,
                title: command.title,
                arguments: command.args,
            },
            range: {
                start: position,
                end: position,
            },
        }); });
    });
}
function findNodesAtLocation(root, path) {
    var e_1, _a;
    if (!root) {
        return [];
    }
    var nodes = [root];
    var _loop_1 = function (segment) {
        if (segment === "*") {
            nodes = nodes.flatMap(function (s) { var _a; return (_a = s.children) !== null && _a !== void 0 ? _a : []; });
            return "continue";
        }
        if (typeof segment === "number") {
            var index_1 = segment;
            nodes = nodes.flatMap(function (n) {
                if (n.type !== "array" || index_1 < 0 || !Array.isArray(n.children) || index_1 >= n.children.length) {
                    return [];
                }
                return [n.children[index_1]];
            });
        }
        if (typeof segment === "string") {
            nodes = nodes.flatMap(function (n) {
                var e_2, _a;
                if (n.type !== "object" || !Array.isArray(n.children)) {
                    return [];
                }
                try {
                    for (var _b = (e_2 = void 0, __values(n.children)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var prop = _c.value;
                        if (Array.isArray(prop.children) && prop.children[0].value === segment && prop.children.length === 2) {
                            return [prop.children[1]];
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                return [];
            });
        }
    };
    try {
        for (var path_2 = __values(path), path_2_1 = path_2.next(); !path_2_1.done; path_2_1 = path_2.next()) {
            var segment = path_2_1.value;
            _loop_1(segment);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (path_2_1 && !path_2_1.done && (_a = path_2.return)) _a.call(path_2);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return nodes;
}
exports.findNodesAtLocation = findNodesAtLocation;
//# sourceMappingURL=SwfJsonLanguageService.js.map