"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFunctions = void 0;
var jsonc = require("jsonc-parser");
function getFunctions(rootNode) {
    var _a;
    var functionsNode = jsonc.findNodeAtLocation(rootNode, ["functions"]);
    if ((functionsNode === null || functionsNode === void 0 ? void 0 : functionsNode.type) !== "array") {
        return [];
    }
    return Array.from((_a = functionsNode.children) !== null && _a !== void 0 ? _a : []).flatMap(function (functionNode) {
        var _a, _b;
        var name = (_a = jsonc.findNodeAtLocation(functionNode, ["name"])) === null || _a === void 0 ? void 0 : _a.value;
        var operation = (_b = jsonc.findNodeAtLocation(functionNode, ["operation"])) === null || _b === void 0 ? void 0 : _b.value;
        if (!name || !operation) {
            return [];
        }
        return [{ name: name, operation: operation }];
    });
}
exports.getFunctions = getFunctions;
//# sourceMappingURL=modelQueries.js.map